Jonathan Hinds
Code Sample: RecursionExampleDirectory

//pre: n >= 0
//method fact takes in an int >= 0
public static int fact(int n)
{
  //initialize the result to 0
  int result = 0;
  //if the number entered is 0
  if(n == 0)
    //set result to 1
    result = 1;
  //if the number entered is not 0
  else
    //the result is set = to the original input * the result
    //of fact if you subtract 1 from the original input
    result = n * fact(n-1);
    //
  return result;
}

the fact method takes in an integer ( n ) which must be greater than 0
and outputs an integer ( result ) which is a product of n * (n - 1).
This method recursively calls itself, multiplying itself by 1 less of
what its original input was and exiting once ( n ) the input is 0, the
code then continues in order downward to the return of the result.
this means, 5 goes in, 5 isn't 0 so we call fact again on n-1
this means, 4 goes in, 4 isn't 0 so we call fact again on n-1
this means, 3 goes in, 3 isn't 0 so we call fact again on n-1
... and so forth until 0 goes in.
Once 0 goes in, we see that n == 0; set result to 1 and move outward returning
the result to the previous time fact was called.
this means when n == 0, return 1 to the previous time it was calculated.
the previous time it was calculated ( n + 1 ) n was == 1. before that n == 2
before that n == 3 each time multiplying itself by what it was previously.
Recursion can be used to execute a task any number of times until a specific
result is shown. This would be used in place of a for or while loop
when its unknown how many times the method needs to run. In the event
that the exit condition is never specified or never met - recursion will
take place infinitely until a memory error occurs.
